# Originally generated by go2rpm 1.3
%bcond_without check

# https://github.com/coreos/butane
%global goipath         github.com/coreos/butane
Version:                0.16.0

%gometa

%global common_description %{expand:
Butane translates human-readable Butane Configs into machine-readable Ignition
configs for provisioning operating systems that use Ignition.}

Name:           butane
Release:        2.2.rhaos4.12%{?dist}
Summary:        Butane config transpiler

# Upstream license specification: Apache-2.0
License:        ASL 2.0
URL:            %{gourl}
Source0:        %{gosource}

ExclusiveArch: %{go_arches}
BuildRequires: compiler(go-compiler)

# Generated by go-mods-to-bundled-provides.py
Provides: bundled(golang(github.com/clarketm/json)) = 1.17.1
Provides: bundled(golang(github.com/coreos/go-semver/semver)) = 0.3.0
Provides: bundled(golang(github.com/coreos/go-systemd/v22/unit)) = 22.4.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/merge)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/shared/errors)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/shared/validations)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/util)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/v3_0/types)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/v3_1/types)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/v3_2/types)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/v3_3/types)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/v3_4_experimental/types)) = 2.14.0
Provides: bundled(golang(github.com/coreos/ignition/v2/config/validate)) = 2.14.0
Provides: bundled(golang(github.com/coreos/vcontext/json)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/coreos/vcontext/path)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/coreos/vcontext/report)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/coreos/vcontext/tree)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/coreos/vcontext/validate)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/coreos/vcontext/yaml)) = 0.0.0-20220810162454.git88bd546c634c
Provides: bundled(golang(github.com/spf13/pflag)) = 1.0.6-0.20210604193023.gitd5e0c0615ace
Provides: bundled(golang(github.com/stretchr/testify/assert)) = 1.8.0
Provides: bundled(golang(github.com/vincent-petithory/dataurl)) = 1.0.0
Provides: bundled(golang(gopkg.in/yaml.v3)) = 3.0.1

%description
%{common_description}

%package redistributable
Summary:       Butane for macOS and Windows
License:       ASL 2.0
BuildArch:     noarch

%description redistributable
%{common_description}

This package contains macOS and Windows Butane binaries built through
cross-compilation.

%prep
%autosetup -p1

%build
export LDFLAGS="-X github.com/coreos/butane/internal/version.Raw=%{version} $LDFLAGS"
export GOFLAGS="-mod=vendor"
export GO111MODULE=on

# Set up PWD as a proper import path for go
mkdir -p src/%{provider}.%{provider_tld}/%{project}
ln -s ../../../ src/%{provider_prefix}

echo "Building butane..."
%gobuild -o ./butane internal/main.go

%global gocrossbuild go build -ldflags "${LDFLAGS:-} -B 0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \\n')" -a -v -x 

echo "Building macOS Butane..."
GOARCH=amd64 GOOS=darwin %gocrossbuild -o butane-darwin-amd64 internal/main.go

echo "Building Windows Butane..."
GOARCH=amd64 GOOS=windows %gocrossbuild -o butane-windows-amd64.exe internal/main.go

%install
install -d -p %{buildroot}%{_bindir}
install -p -m 0755 ./butane %{buildroot}%{_bindir}
install -d -p %{buildroot}%{_datadir}/butane-redistributable
install -p -m 0644 ./butane-darwin-amd64 %{buildroot}%{_datadir}/butane-redistributable
install -p -m 0644 ./butane-windows-amd64.exe %{buildroot}%{_datadir}/butane-redistributable

%if %{with check}
%check
export GOFLAGS="-mod=vendor"
export GO111MODULE=on
go test ./...
%endif

%files
%license LICENSE
%doc docs README.md
%{_bindir}/butane

%files redistributable
%license LICENSE
%dir %{_datadir}/butane-redistributable
%{_datadir}/butane-redistributable/butane-darwin-amd64
%{_datadir}/butane-redistributable/butane-windows-amd64.exe

%changelog
* Mon Mar 25 2024 AOS Automation Release Team <aos-team-art@redhat.com> - 0.16.0-2.2.rhaos4.12
Bump and rebuild with latest golang, resolves ART-9185

* Thu Oct 19 2023 Siddharth Sharma <sidsharm@redhat.com> - 0.16.0-2.1.rhaos4.12
Bump and rebuild with latest golang, resolves ART-7948

* Wed Nov 02 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.16.0-2
- Rebuild with Go 1.19.2 for OCPBUGS-2242

* Fri Oct 14 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.16.0-1
- New release

* Tue Aug 02 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.15.0-3
- Rebuild with Go 1.18.4

* Mon Jul 25 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.15.0-2
- Rebuild with Go 1.18.2

* Thu Jun 23 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.15.0-1
- New release

* Fri May 20 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.14.0-2
- Rebuild with newer Go

* Thu Jan 27 2022 Benjamin Gilbert <bgilbert@redhat.com> - 0.14.0-1
- New release

* Wed Aug 04 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.13.1-1
- New release

* Wed Jul 14 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.13.0-1
- New release

* Thu Jun 10 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.12.1-1
- New release

* Wed Jun 09 2021 Sohan Kunkerkar <skunekrk@redhat.com> - 0.12.0-1
- New release

* Wed Apr 28 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.11.0-3
- Add note to MachineConfig output warning against editing

* Tue Apr 20 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.11.0-2
- Disable btrfs filesystem on openshift variants

* Fri Apr 09 2021 Benjamin Gilbert <bgilbert@redhat.com> - 0.11.0-1
- Initial package
